Bug 14022 - Typographic variants for ru, ua and us layouts
Summary: Typographic variants for ru, ua and us layouts
Status: RESOLVED FIXED
Alias: None
Product: xkeyboard-config
Classification: Unclassified
Component: General (show other bugs)
Version: unspecified
Hardware: Other All
: medium enhancement
Assignee: xkb
QA Contact:
URL:
Whiteboard:
Keywords: patch
Depends on: 19563
Blocks:
  Show dependency treegraph
 
Reported: 2008-01-11 07:09 UTC by Alexey Ten
Modified: 2009-01-27 14:16 UTC (History)
4 users (show)

See Also:
i915 platform:
i915 features:


Attachments
layouts (6.12 KB, patch)
2008-01-11 07:09 UTC, Alexey Ten
Details | Splinter Review
Modified Birman's typographic layout (4.48 KB, patch)
2008-01-13 08:56 UTC, Alexey Ten
Details | Splinter Review
Modified Birman's typographic layout (5.40 KB, patch)
2008-01-18 22:14 UTC, Alexey Ten
Details | Splinter Review
typographic layout (4.47 KB, patch)
2008-01-19 13:16 UTC, Alexey Ten
Details | Splinter Review
Typographic layout options (9.67 KB, patch)
2009-01-11 12:48 UTC, Alexey Ten
Details | Splinter Review
Fix bug with Shift-Arrows text selection (3.35 KB, patch)
2009-01-26 11:53 UTC, Alexey Ten
Details | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Alexey Ten 2008-01-11 07:09:14 UTC
Created attachment 13658 [details] [review]
layouts

Typographic variants for ru and us layouts.

There are two version: 
1. simple (my preferred);
2. slightly modified Ilya Birman's one (http://ilyabirman.ru/tools/typography-layout/)
Comment 1 Sergey V. Udaltsov 2008-01-11 14:26:50 UTC
I do not mind these layouts, but could you please estimate how many people are actually using (or will be using immediately once these layouts are available)? I just would not like to add hackish variants used by "the author and his friend", you know...
Comment 2 Alexey Ten 2008-01-13 07:34:56 UTC
(In reply to comment #1)
Do you mean my version or Birman's version or both?

For now, I think that there should be one version of typographic layout and let it be Ilya Birman's one, because it has more symbols.
Comment 3 Sergey V. Udaltsov 2008-01-13 07:40:55 UTC
> Do you mean my version or Birman's version or both?
Actually, my question was related to both variants.

> For now, I think that there should be one version of typographic layout and let
> it be Ilya Birman's one, because it has more symbols.
Sounds reasonable. So, once you answer the question above - looking forward to the updated patch;)
Comment 4 Alexey Ten 2008-01-13 08:27:28 UTC
> Sounds reasonable. So, once you answer the question above - looking forward to
> the updated patch;)

http://regolit.com/posts/xkb_unicode#comment-6 ;)
http://www.google.com/search?q=%D1%82%D0%B8%D0%BF%D0%BE%D0%B3%D1%80%D0%B0%D1%84%D1%81%D0%BA%D0%B0%D1%8F+%D1%80%D0%B0%D1%81%D0%BA%D0%BB%D0%B0%D0%B4%D0%BA%D0%B0

I think it's quite popular in some circles. And it's deserved to be included to standard =)
Comment 5 Sergey V. Udaltsov 2008-01-13 08:33:30 UTC
Ok, I think it is enough evidence for one variant :)
Comment 6 Alexey Ten 2008-01-13 08:56:01 UTC
Created attachment 13696 [details] [review]
Modified Birman's typographic layout
Comment 7 Sergey V. Udaltsov 2008-01-13 13:34:47 UTC
Ok, this one is shorter, good. Now that I am looking at it, I got another question, probably stupid. Why not make it not a variant but XkbOption? This way, any xkb configuration could be "typograpised" with one mouse click? Would it make sense?
Comment 8 Alexey Ten 2008-01-13 20:27:19 UTC
I thought on it, but almost every layout has it's own third level.

It make sense to add this variant to Ukrainian layout though.
Comment 9 Sergey V. Udaltsov 2008-01-14 11:22:14 UTC
> I thought on it, but almost every layout has it's own third level.
Well, in that case people would lose some characters. Their choice, isn't it?

> It make sense to add this variant to Ukrainian layout though.
May be, there are some other variant - I simply do not remember all 2-level layouts/variants...

Comment 10 Alexey Ten 2008-01-14 20:25:33 UTC
> Well, in that case people would lose some characters. Their choice, isn't it?
Yes, but I hardly imagine german or czech, who would use this option and lost their native symbols...

BTW do you mean option which affect all chosen layouts (so checking this option will typographize all my three layouts) or an option for every layout (so I have to check three options to have all my layouts typographized)?
Comment 11 Sergey V. Udaltsov 2008-01-15 02:59:01 UTC
> Yes, but I hardly imagine german or czech, who would use this option and lost
> their native symbols...
So, they just will never use that option - or use only once, for 5 mins;)

> BTW do you mean option which affect all chosen layouts (so checking this option
> will typographize all my three layouts) or an option for every layout (so I
> have to check three options to have all my layouts typographized)?
I'd guess it will affect all layouts. The group #1 would have levels 3 and 4 fully typograhic, while the rest would have typographic characters on positions not taken by existing keysyms. But it is just my guess - I can be wrong here, it should be checked.
Comment 12 Alexey Ten 2008-01-17 21:05:56 UTC
(In reply to comment #11)
> > Yes, but I hardly imagine german or czech, who would use this option and lost
> > their native symbols...
> So, they just will never use that option - or use only once, for 5 mins;)
But, if I use russian and german layouts I have no way to have typographic symbols in russian layout, because, if I turn option on I'll loose german native letters.

> > BTW do you mean option which affect all chosen layouts (so checking this option
> > will typographize all my three layouts) or an option for every layout (so I
> > have to check three options to have all my layouts typographized)?
> I'd guess it will affect all layouts. The group #1 would have levels 3 and 4
> fully typograhic, while the rest would have typographic characters on positions
> not taken by existing keysyms. But it is just my guess - I can be wrong here,
> it should be checked.
Actually, third level doesn't wrap to next layout if it's not defined in current layout. This is what bug #14074 about.
Comment 13 Alexey Ten 2008-01-17 23:19:44 UTC
Let me describe use cases of typographic layout as I see them:

1. User has Russian and US layouts. That's 99% of Russian.
   These two layout variants are perfectly fit for those of them who
   cares for "fancy" symbols.
   The option "typographize" also fits their needs.

2. User has Russian and some European layout (say, French).
   If there is layout variants, user will use ru(typo),fr and will be happy.
   If there is option, user will try it, loose french symbols, and roll back,
   so he will have no typographic layout in Russian

3. User has only one layout (say, Netherlands).
   He doesn't need typographic layout, because he already has most of
   "fancy" symbols (guillemots, etc.)


I think that typographic layout is suitable only for some of exUSSR countries (Cyrillic-based) since other countries either already has sort of it (European) or doesn't need it (Arabic and other non-Latin based)
Comment 14 Alexey Ten 2008-01-18 22:14:14 UTC
Created attachment 13787 [details] [review]
Modified Birman's typographic layout

Small fix to layout (remove approxeq from key "1")
Add Ukraine variant
Comment 15 Andriy Rysin 2008-01-19 09:33:11 UTC
(In reply to comment #14)
> Small fix to layout (remove approxeq from key "1")
> Add Ukraine variant

Actually ua layout already has "Unicode" variant which covers most of the frequently used typographic symbols and is used by many people. What's the advantage of adding another one which is very close to existing one?
Comment 16 Alexey Ten 2008-01-19 10:51:40 UTC
> Actually ua layout already has "Unicode" variant which covers most of the
> frequently used typographic symbols and is used by many people.
Well, actually I'm using xkb-data v0.9 which hasn't unicode layout.

> What's the advantage of adding another one which is very close
> to existing one?
There is no one.

(In reply to comment #7)
We can see in many layouts there is already "typographic" version so there is no need to have option which typographize all layouts.
Comment 17 Andriy Rysin 2008-01-19 11:15:13 UTC
(In reply to comment #16)
> > Actually ua layout already has "Unicode" variant which covers most of the
> > frequently used typographic symbols and is used by many people.
> Well, actually I'm using xkb-data v0.9 which hasn't unicode layout.
> 
> > What's the advantage of adding another one which is very close
> > to existing one?
> There is no one.
there is one in CVS, it was commited recently, will be present in next version of xkb-data (and thus x.org), available on other platforms ;), has wikipedia article about it, was heavily discussed and adjusted by ukrainian OSS community.

In layout "ua" the variant is called "unicode".
Comment 18 Alexey Ten 2008-01-19 13:16:52 UTC
Created attachment 13802 [details] [review]
typographic layout

removed ua version, because there is ua(unicode)
Comment 19 Alexey Torkhov 2008-01-20 03:43:25 UTC
(In reply to comment #18)
> typographic layout

Your layout is based on ru(winkeys) and what about of having typographic layout based on ru(typewriter) and ru(basic) ?
Comment 20 Alexey Ten 2009-01-09 12:40:17 UTC
I've created a XkbOptions variant(In reply to comment #7)
> Ok, this one is shorter, good. Now that I am looking at it, I got another
> question, probably stupid. Why not make it not a variant but XkbOption? This
> way, any xkb configuration could be "typograpised" with one mouse click? Would
> it make sense?
> 

It took me about a year but I've done it :)
You can see my version at github
http://github.com/alexeyten/xkeyboard-config
The commits are http://github.com/alexeyten/xkeyboard-config/commit/9848bfb56 and next one
Comment 21 Alexey Ten 2009-01-10 14:11:59 UTC
One can test package for Ubuntu 8.10 (intrepid)
https://launchpad.net/~alexeyten/+archive
Comment 22 Sergey V. Udaltsov 2009-01-10 15:03:39 UTC
> It took me about a year but I've done it :)
Well done! And looking at your patch - I must admit it is a sophisticated one;)

> You can see my version at github
> http://github.com/alexeyten/xkeyboard-config
> The commits are http://github.com/alexeyten/xkeyboard-config/commit/9848bfb56
> and next one
Well, I am not advanced in git enough to get the code straight from your git, so could you please attach a patch?
Comment 23 Alexey Ten 2009-01-11 12:48:07 UTC
Created attachment 21888 [details] [review]
Typographic layout options

This is a git format-patch result
Use git-am to merge it
Comment 24 Sergey V. Udaltsov 2009-01-11 14:37:47 UTC
Well, I see 2 variants here. Would it make sense to drop v1, is it obsolete? Could you please give some background about these versions?
Comment 25 Sergey V. Udaltsov 2009-01-11 14:40:15 UTC
The patches for symbols/fr and rules/base.xml look ok to me. Will apply them.
Comment 26 Sergey V. Udaltsov 2009-01-11 15:16:15 UTC
Oops, sorry last comment was to the wrong bug:)
Comment 27 Sergey V. Udaltsov 2009-01-13 08:07:40 UTC
There is discussion (in Russian):

http://www.linux.org.ru/view-message.jsp?msgid=3408402&lastmod=1231862494585

Alexey, interested?
Comment 28 Sergey V. Udaltsov 2009-01-13 15:03:29 UTC
Committed as typo:misc (the last variant proposed on linux.org.ru). Not working (yet) because of the issues with rules/base
Comment 29 Sergey V. Udaltsov 2009-01-14 15:32:30 UTC
Since 19563 is closed, I am closing this one too. Unless someone is unhappy.
Comment 30 Alexey Ten 2009-01-14 21:45:55 UTC
We should add some comments with respects to Ilya Birman and me ;)
Comment 31 Sergey V. Udaltsov 2009-01-15 01:31:02 UTC
I totally support that! Added a couple of lines into the symbols/typo. Is that good enough?
Comment 32 Alexey Ten 2009-01-15 02:12:54 UTC
(In reply to comment #31)
> I totally support that! Added a couple of lines into the symbols/typo. Is that
> good enough?
> 

Yes. That's fine
Comment 33 Alexey Ten 2009-01-26 11:21:07 UTC
I've found a problem with this layout.
Shift+Arrow doesn't extends text selection.
Comment 34 Alexey Ten 2009-01-26 11:53:06 UTC
Created attachment 22254 [details] [review]
Fix bug with Shift-Arrows text selection

Patch to fix the bug (removes symbols from arrow keys) + some clean up
Comment 35 Sergey V. Udaltsov 2009-01-27 14:16:08 UTC
ok, fixed, thanks!


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct.